
# Kubernetes bebida aware action

This action should profit from an offload infrastructure that is dynamically
connected to kubernetes. In order to work it launches a spark submit in 
cluster mode, with spark driver and master on the current process. This will
allow to spam multiple exporters on the desired nodes. To enable this pod to
enact on kube some configurations are required. See next how to configure the
exporter pods template and tolerations.

## Configuration

### serviceAccountName

This action will require kubernetes addon to
associate with a serviceAccountName that can list/delete/create on
services, pods, and configmaps kubernetes' resources. 
This will grant kube access required for spark to spam the workers across 
desired kubernetes nodes.
The serviceAccount must  be created beforehand in namespace `ryaxns-execs` 
with a serviceAccountName that is later used with the kubernetes addon. 
To edit the kubernetes addon serviceAccountName one can either edit the
workflow on Ryax UI before deployment or provide an initial value in `ryax_metadata.yaml`.

To create the service account with the right permissions you can use a sample
yaml in this project `spark-rbac.yaml`. To apply that file you are required to
have administration rights on the cluster to issue a `kubectl apply` command
as below.

```shell
kubectl apply -f spark-rbac.yaml
```

To check if the service account has the correct permission you can run the command
below.

```shell
for op in "list" "delete" "create" "update"
do 
    for resource in "pods" "services" "configMaps"
    do 
      echo "Checking for $op on $resource =====>" `kubectl auth can-i $op $resource --as=system:serviceaccount:ryaxns-execs:spark -n ryaxns-execs`
    done
done
```

Note to azure clusters, if you get the responce `no Azure has no opinion for
this user` this means the rbac is not working, double check the namespace
in all resource and reapply `spark-rbac.yaml`.

### Tolerations

The infrastructure
requires nodes to tolerate tainted nodes, for this the `exporter-pod-template.yaml`
file is used. 

```yaml
apiVersion: batch/v1
kind: Job
metadata:
  name: exporter-pod-template
spec:
  template:
    # This is the pod template
    spec:
      tolerations:
        - key: "spark"
          operator: "Equal"
          value: "bebida"
          effect: "NoSchedule"
    # The pod template ends here
```

The template state by default the toleration of taint `spark=bebida:NoSchedule`, so nodes
should receive the taint like in the example below:

```shell
kubectl taint nodes bebidanode spark=bebida:NoSchedule
```

